unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Laz.VirtualTrees;

type
  
  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    VirtualStringTree1: TLazVirtualStringTree;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure VirtualStringTree1FreeNode(Sender: TBaseVirtualTree; 
      Node: PVirtualNode);
    procedure VirtualStringTree1GetNodeDataSize(Sender: TBaseVirtualTree; 
      var NodeDataSize: Integer);
    procedure VirtualStringTree1GetText(Sender: TBaseVirtualTree; 
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; 
      var CellText: String);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

type
  TNodeData = TStrings;
  PNodeData = ^TNodeData;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  P: PNodeData;
  strings: TStringList;
  node: PVirtualNode;
  i: Integer;
begin
  node := VirtualStringTree1.AddChild(VirtualStringTree1.FocusedNode);
  P := VirtualStringTree1.GetNodeData(node);
  strings := TStringList.Create;
  for i := 0 to VirtualstringTree1.Header.Columns.Count-1 do
    strings.Add(Format('Node %d / Column %d', [node^.Index, i]));
  P^ := strings;
  VirtualStringTree1.Expanded[VirtualStringTree1.FocusedNode] := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  VirtualStringTree1.DeleteNode(VirtualStringTree1.FocusedNode);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  VirtualstringTree1.Selected[VirtualStringTree1.FocusedNode] := false;
  VirtualStringTree1.FocusedNode := nil;
end;

procedure TForm1.VirtualStringTree1FreeNode(Sender: TBaseVirtualTree; 
  Node: PVirtualNode);
var
  P: PNodeData;
begin
  P := Sender.GetNodeData(Node);
  TStrings(P^).Free;
end;

procedure TForm1.VirtualStringTree1GetNodeDataSize(Sender: TBaseVirtualTree; 
  var NodeDataSize: Integer);
begin
  NodeDataSize := SizeOf(PNodeData);
end;

procedure TForm1.VirtualStringTree1GetText(Sender: TBaseVirtualTree; 
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; 
  var CellText: String);
var
  P: PNodeData;
  strings: TStrings;
begin
  P := Sender.GetNodeData(Node);
  strings := TStringList(P^);
  CellText := strings[Column];
end;

end.

